
#define     _DEG_AS_mm (60000u)        /*   1 degree, 60 minutes */
#define  _90_DEG_AS_mm (60000uL *  90) /*  90 degrees */
#define _180_DEG_AS_mm (60000uL * 180) /* 180 degrees */

/* in ordinates, north/east are positive */

#define negative_hemisphere(dw) (*(byte *) &(dw) & 0x80)

struct coord {
	long lat, lon; /* signed milliminutes */
};

struct vector {
	struct coord coord;
	word course, knots;
};

struct area {
	word radius;
	struct coord *center; /* to fixed center location or to 'gps' etc */
};

extern word
	HDOP, VDOP,
	gps_satellites;

void sted_gps_altitude(long meters);

