
	global	_word_bitmask

	section	.data
	align	1
_word_bitmask
	dc.w	1
	dc.w	2
	dc.w	4
	dc.w	8
	dc.w	16
	dc.w	32
	dc.w	64
	dc.w	128
	dc.w	256
	dc.w	512
	dc.w	1024
	dc.w	2048
	dc.w	4096
	dc.w	8192
	dc.w	16384
	dc.w	-32768

	global	_byte_bitmask
_byte_bitmask
	dc.b	1
	dc.b	2
	dc.b	4
	dc.b	8
	dc.b	16
	dc.b	32
	dc.b	64
	dc.b	128

	global	_hex_characters
_hex_characters
	dc.b	030h,031h,032h,033h,034h,035h,036h,037h
	dc.b	038h,039h,041h,042h,043h,044h,045h,046h
	dc.b	047h,048h,049h,04Ah,04Bh,04Ch,04Dh,04Eh
	dc.b	04Fh,050h,051h,052h,053h,054h,055h,056h
	dc.b	000h

	align	1	; ASM_OUTPUT_ASCII

	section	.text
	align	1

	global	_strstr
_strstr
	pshm	z
	ais	#-8
	tsz

	ste	0,z
	std	2,z
	ldy	2,z
	tst	0,y
	beq	L8
	
	jsr	_strend
	std	6,z
	lde	2,z
	jsr	_strlen
	lde	6,z
	sde	
	ste	4,z
	ldy	0,z
	cpy	4,z
	bhi	L4
	

L6	lde	0,z
	ldd	2,z
	jsr	_substrcmp
	tstd	
	beq	L8
	
	incw	0,z
	lde	0,z
	cpe	4,z
	bls	L6
	

L4	clrw	0,z

L8	ldd	0,z

	ais	#+8
	pulm	z
	rts

	align	1

	global	_strcatx
_strcatx
	pshm	z
	ais	#-2
	tsz

	std	0,z
	jsr	_strend
	tde	
	ldd	0,z
	jsr	_strcpyx

	ais	#+2
	pulm	z
	rts

	align	1

	global	_print_hexdump
_print_hexdump
	pshm	z
	ais	#-4
	tsz

	std	0,z
	ste	2,z
	bra	L16
	

L14	ldy	2,z
	ldab	0,y
	clra	
	incw	2,z
	tde	
	jsr	_print_byte

L16	decw	0,z
	ldy	0,z
	cpy	#-1
	bne	L14
	

	ais	#+4
	pulm	z
	rts

	align	1

	global	_print_short
_print_short
	pshm	z
	ais	#-6
	tsz

	ted	
	tze	
	jsr	_sprint_u
	tze	
	jsr	_print_string

	ais	#+6
	pulm	z
	rts

	align	1

	global	_print_02u
_print_02u
	pshm	z
	ais	#-6
	tsz

	ted	
	stz	4,z
	lde	4,z
	jsr	_sprint_02u
	ldy	4,z
	clr	2,y
	lde	4,z
	jsr	_print_string

	ais	#+6
	pulm	z
	rts


	section	.data

LC0	dc.b	020h,030h,000h

	align	1	; ASM_OUTPUT_ASCII

	section	.text
	align	1

	global	_print_signed_short
_print_signed_short
	pshm	z
	ais	#-2
	tsz

	ste	0,z
	ble	L20
	
	lde	#43
	jsr	_putchar
	lde	0,z
	jsr	_print_short
	bra	L19
	

L20	tstw	0,z
	bge	L21
	
	lde	#45
	jsr	_putchar
	lde	0,z
	nege	
	jsr	_print_short
	bra	L19
	

L21	lde	#LC0
	jsr	_print_string

L19
	ais	#+2
	pulm	z
	rts

	align	1

	global	_print_short_N
_print_short_N
	pshm	z
	ais	#-10
	tsz

	tey	
	std	6,z
	tze	
	tyd	
	jsr	_sprint_u
	std	8,z
	bra	L27
	

L25	lde	#32
	jsr	_putchar

L27	lde	8,z
	tzd	
	sde	
	incw	8,z
	cpe	6,z
	blt	L25
	
	tze	
	jsr	_print_string

	ais	#+10
	pulm	z
	rts

	align	1

	global	_print_signed_long
_print_signed_long
	pshm	z
	ais	#-16
	tsz

	ste	12,z
	std	14,z
	tste	
	bge	L29
	
	tze	
	aie	#12
	jsr	_lnegate
	lde	#45
	jsr	_putchar

L29	tzd	
	aid	#12
	tze	
	jsr	_sprint_010Lu
	tzy	
	ldab	0,z
	cmpb	#48
	bne	L32
	

L35	tst	1,y
	beq	L32
	
	xgdy	
	addd	#1
	xgdy	
	ldab	0,y
	cmpb	#48
	beq	L35
	

L32	tye	
	jsr	_print_string

	ais	#+16
	pulm	z
	rts

	align	1

	global	_print_dword
_print_dword
	pshm	z
	tsz

	ldd	#4
	jsr	_print_hexdump
	pulm	z
	rts


	section	.data

LC1	dc.b	05Ch,078h,000h

	align	1	; ASM_OUTPUT_ASCII

	section	.text
	align	1

	global	_vis
_vis
	pshm	z
	ais	#-4
	tsz

	ste	0,z
	tdy	
	xgdy	
	addd	0,z
	xgdy	
	sty	2,z
	bra	L45
	

L41	ldx	0,z
	ldab	0,x
	addb	#-32
	cmpb	#94
	bhi	L42
	
	ldab	0,x
	cmpb	#92
	beq	L42
	
	clra	
	tde	
	jsr	_putchar
	bra	L40
	

L42	lde	#LC1
	jsr	_print_string
	ldx	0,z
	ldab	0,x
	clra	
	tde	
	jsr	_print_byte

L40	incw	0,z

L45	ldx	0,z
	cpx	2,z
	blo	L41
	

	ais	#+4
	pulm	z
	rts

	align	1

	global	_wildmat
_wildmat
	pshm	z
	ais	#-4
	tsz

	ste	0,z
	std	2,z
	bra	L64
	

L50	ldy	0,z
	ldab	0,y
	cmpb	#42
	beq	L51
	
	ldy	2,z
	cmpb	0,y
	beq	L49
	
	cmpb	#63
	bne	L54
	
	tst	0,y
	bne	L49
	
	bra	L54
	

L51	incw	0,z
	ldy	0,z
	tst	0,y
	beq	L65
	
	bra	L56
	

L58	ldd	2,z
	incw	2,z
	lde	0,z
	jsr	_wildmat
	tstb	
	bne	L65
	

L56	ldy	2,z
	tst	0,y
	bne	L58
	

L54	clrd	
	bra	L63
	

L49	incw	2,z
	incw	0,z

L64	ldy	0,z
	tst	0,y
	bne	L50
	
	clrd	
	ldy	2,z
	tst	0,y
	bne	L63
	

L65	ldd	#1

L63
	ais	#+4
	pulm	z
	rts



	end
