
	section .init         ; fixed address 3:0

	global text_start

text_start

	orp  # 00F0h          ; also set dsp saturation mode, just for fun    

	; copy .data from 0x2C000 eeprom block
	; and clear .bss, ... .stack

	ldd # __EE_page       ; 2
	tbxk
	ldx # __data_image    ; stash of initialized data here

	ldd # __data_page     ; 0
	tbyk
	ldy # __data          ; proper location is here

L0
	ldab 0,x
	stab 0,y
	aix  #+1
	aiy  #+1
	cpy  # __edata
	bne  L0
L1
	clr  0,y
	aiy  #+1
	bne  L1               ; while we are at it, zap all of ram (yk++)

	; clear internal RAM too

	ldab # 0FFh
	tbyk
	ldy  # 0
L2
	clr  0,y
	aiy  #+1
	cpy  # 0400h          ; 1024 bytes of ram at F:0
	bne  L2

	; call main()

	ldd  # __data_page
	tbek
	tbxk
	tbyk
	tbzk                  ; only place
	tbsk                  ; only place
	lds  # __stack
	ldz  # 0

	jsr  _main            ; still ipl 7
	tde
	jmp  _reboot

	end

