
typedef byte ieee_float [4]; /* 32 bit IEEE 1,  8 excess  127 and 23 */
typedef byte ieee_double[8]; /* 64 bit IEEE 1, 11 excess 1023 and 52 */


/* 32-bit IEEE 1-bit sign, 8-bit excess-127 exponent and 23-bit mantissa */

long ieee_float_to_long(ieee_float f, int scale);

/* 64-bit IEEE 1-bit sign, 11-bit excess-1023 exponent and 52-bit mantissa */

long ieee_double_to_long(ieee_double d, int scale);

