
	; 16kB window at 28000h

SEGMENT equ 2
LENGTH  equ 4000h

	;  Must live in ram, obviously.
	;  XXX ipl 5 could be used,
	;  XXX pit (at 2) might call tx_proc in flash,
	;  XXX but other interrupts are --- ARE NOT, keypad
	;  XXX calls also flash code. grumble.
	;-------------------------------------
	section .inthand
	align 1

	global _flash_erase
	global _flash_write

_flash_erase        ; void flash_erase(void)

	pshm k,ccr

	ldab # SEGMENT
	tbek

	orp  # 00E0h

	ldaa # 0AAh
	staa 5555h
	ldaa # 055h
	staa 2AAAh
	ldaa # 080h
	staa 5555h
	ldaa # 0AAh
	staa 5555h
	ldaa # 055h
	staa 2AAAh
	ldaa # 030h
	staa __cfg_block

	brclr __cfg_block, # 80h, *

	pulm k,ccr
	rts

_flash_write        ; void flash_write(word offset_from_28000, byte)

	cpe  # LENGTH
	bcc  L2         ; huh
	adde # __cfg_block
	xgex            ; pointer in IX
	xgab            ; byte in A

	pshm k,ccr

	ldab # SEGMENT
	tbek
	tbxk

	orp  # 00E0h

	ldab # 0AAh
	stab 5555h
	ldab # 055h
	stab 2AAAh
	ldab # 0A0h
	stab 5555h
	staa 0,x
L1
	tab
	eorb 0,x
	bmi  L1         ; busywait the programming period

	pulm k,ccr
L2
	rts

	;-----------------------------------------------------------
	section .text
	align 1

	global _flash_read

_flash_read         ; byte flash_read(word offset_from_28000)

	pshm k
	adde # __cfg_block
	xgex

	ldab # SEGMENT
	tbxk

	ldab 0,x
	pulm k
	clra
	rts

