
	section	.text
	align	1
_free_one
	pshm	z
	tsz

	tex	
	ldy	0,x
	beq	L2
	
	ldd	0,y
	std	0,x
	ldd	_msg_free
	std	0,y
	sty	_msg_free

L2	pulm	z
	rts

	align	1
_bump
	pshm	z
	ais	#-2
	tsz

	tey	
	ldab	#2
	stab	0,z

L4	ldab	1,y
	clra	
	tde	
	cpe	#90
	beq	L10
	
	bgt	L14
	
	tste	
	beq	L12
	
	cpe	#57
	beq	L9
	
	bra	L8
	

L14	cpe	#122
	beq	L12
	

L8	inc	1,y
	bra	L3
	

L9	ldab	#65
	stab	1,y
	bra	L3
	

L10	ldab	#97
	stab	1,y
	bra	L3
	

L12	ldab	#48
	stab	1,y
	xgdy	
	addd	#-1
	xgdy	
	dec	0,z
	bne	L4
	

L3
	ais	#+2
	pulm	z
	rts

	align	1
_discard_sendq
	pshm	z
	ais	#-4
	tsz

	ste	0,z
	ldy	0,z
	tstw	16,y
	beq	L18
	
	xgdy	
	addd	#16
	xgdy	
	sty	2,z

L19	lde	2,z
	jsr	_free_one
	ldy	2,z
	tstw	0,y
	bne	L19
	

L18	lde	0,z
	aie	#14
	jsr	_bump

	ais	#+4
	pulm	z
	rts

	align	1
_alloc_xch
	pshm	z
	ais	#-6
	tsz

	ste	0,z
	ldy	#_xch_list
	sty	2,z
	ldx	_xch_list
	bra	L29
	

L25	ldd	4,z
	aid	#2
	lde	0,z
	jsr	_axacmp
	tstd	
	beq	L27
	
	ldd	2,z
	ldy	4,z
	sty	2,z
	ldx	0,y

L29	stx	4,z
	bne	L25
	
	std	2,z
	ldy	2,z
	ldy	0,y
	sty	4,z
	lde	4,z
	jsr	_discard_sendq
	ldx	4,z
	clr	9,x
	lde	4,z
	aie	#2
	ldd	0,z
	jsr	_axacpy

L27	ldy	4,z
	ldx	0,y
	ldy	2,z
	stx	0,y
	ldx	_xch_list
	ldy	4,z
	stx	0,y
	sty	_xch_list
	ldd	4,z

	ais	#+6
	pulm	z
	rts

	align	1
_send_from
	pshm	z
	ais	#-14
	tsz

	ste	4,z
	aie	#2
	tzd	
	aid	#2
	jsr	_aprs_messaging_prologue
	std	6,z
	lbeq	L31
	
	ldy	4,z
	ldy	16,y
	sty	8,z
	lde	8,z
	aie	#3
	ldab	2,y
	clra	
	tdx	
	stx	0,z
	ldd	6,z
	jsr	_bcopy
	ldy	8,z
	ldab	2,y
	clra	
	tde	
	adde	6,z
	ste	6,z
	ldab	#123
	ldy	6,z
	stab	0,y
	ldy	4,z
	ldab	14,y
	ldy	6,z
	stab	1,y
	ldy	4,z
	ldab	15,y
	ldy	6,z
	stab	2,y
	xgdy	
	addd	#3
	xgdy	
	sty	6,z
	ldy	4,z
	tst	9,y
	beq	L32
	
	xgdy	
	addd	#9
	xgdy	
	sty	10,z
	ldab	#125
	ldy	6,z
	stab	0,y
	incw	6,z
	ldab	#5
	stab	12,z

L37	ldy	10,z
	ldab	0,y
	clra	
	tde	
	jsr	_isalnum
	tstb	
	beq	L32
	
	ldy	10,z
	ldab	0,y
	ldy	6,z
	stab	0,y
	incw	10,z
	incw	6,z
	dec	12,z
	bne	L37
	

L32	lde	#3
	jsr	_bits_of_random
	ldy	4,z
	lde	20,y
	aie	#30
	ade	
	ste	20,y
	jsr	_bolt
	ldy	4,z
	std	18,y
	lde	2,z
	ldd	6,z
	jsr	_txq_enter_p

L31
	ais	#+14
	pulm	z
	rts

	align	1

	global	_alloc_msg
_alloc_msg
	pshm	z
	tsz

	jsr	_alloc_xch
	ldy	_msg_free
	beq	L39
	
	ldx	0,y
	stx	_msg_free
	std	0,y

L39	tyd	
	pulm	z
	rts

	align	1

	global	_send_msg
_send_msg
	pshm	z
	ais	#-4
	tsz

	tey	
	ldx	0,y
	stx	0,z
	clr	2,z
	tstw	16,x
	bne	L41
	
	ldab	#1
	stab	2,z

L41	clrw	0,y
	lde	0,z
	aie	#16
	tyd	
	jsr	_link_list_append
	tst	2,z
	beq	L42
	
	ldx	0,z
	clrw	20,x
	lde	0,z
	jsr	_send_from

L42
	ais	#+4
	pulm	z
	rts

	align	1

	global	_msg_exchange
_msg_exchange
	pshm	z
	ais	#-8
	tsz

	std	2,z
	jsr	_alloc_xch
	std	4,z
	tstw	2,z
	beq	L44
	
	aid	#9
	ldy	#5
	sty	0,z
	lde	2,z
	jsr	_bcopy

L44	tstw	14,z
	beq	L45
	
	ldy	4,z
	tstw	16,y
	beq	L45
	
	ldy	14,z
	ldab	0,y
	ldy	4,z
	cmpb	14,y
	bne	L45
	
	ldy	14,z
	ldab	1,y
	ldy	4,z
	cmpb	15,y
	bne	L45
	
	xgdy	
	addd	#16
	xgdy	
	sty	6,z
	lde	6,z
	jsr	_free_one
	lde	4,z
	aie	#14
	jsr	_bump
	ldy	6,z
	tstw	0,y
	beq	L45
	
	ldy	4,z
	clrw	20,y
	lde	4,z
	jsr	_send_from

L45
	ais	#+8
	pulm	z
	rts

	align	1

	global	_timeout_messages
_timeout_messages
	pshm	z
	ais	#-2
	tsz

	ldy	_xch_list
	bra	L56
	

L51	ldy	0,z
	tstw	16,y
	beq	L50
	
	jsr	_bolt
	tde	
	ldy	0,z
	sube	18,y
	cpe	20,y
	bls	L50
	
	lde	20,y
	cpe	#99
	bhi	L53
	
	lde	0,z
	jsr	_send_from
	bra	L50
	

L53	lde	0,z
	jsr	_discard_sendq

L50	ldy	0,z
	ldy	0,y

L56	sty	0,z
	bne	L51
	

	ais	#+2
	pulm	z
	rts

	align	1

	global	_init_message_exchange
_init_message_exchange
	pshm	z
	ais	#-4
	tsz

	clrw	_xch_list
	ldy	#_xch_space
	sty	0,z
	ldy	#_xch_list
	sty	2,z
	lde	#110
	ldd	#22
	jsr	_link_list_use
	clrw	_msg_free
	ldy	#_msg_space
	sty	0,z
	ldy	#_msg_free
	sty	2,z
	lde	#1400
	ldd	#70
	jsr	_link_list_use

	ais	#+4
	pulm	z
	rts


	section	.bss
_msg_free
	ds.b	2
_msg_space
	ds.b	1400
_xch_list
	ds.b	2
_xch_space
	ds.b	110


	end
