
	section	.text
	align	1
_update
	pshm	z
	ais	#-54
	tsz

	ldx	_meas
	stx	12,z
	stx	16,z
	clrw	14,z
	ldx	#100
	stx	0,z
	clrw	2,z
	clre	
	ldd	16,z
	jsr	_EDIV
	tde	
	aie	#-40
	ste	_celsius
	ldx	#500
	stx	0,z
	lde	12,z
	ldd	#9
	jsr	_muldiv
	tde	
	aie	#-40
	ste	_fahrenheit
	ldx	_meas+4
	stx	12,z
	stx	0,z
	lde	#20
	ldd	#48234
	jsr	_EMULx
	ste	18,z
	std	20,z
	lde	12,z
	ldd	12,z
	jsr	_EMUL
	ste	22,z
	std	24,z
	ldx	#94
	stx	0,z
	lde	22,z
	ldd	24,z
	jsr	_EMULx
	ste	26,z
	std	28,z
	ldd	2+18,z
	subd	2+26,z
	std	2+42,z
	ldd	0+18,z
	sbcb	1+26,z
	sbca	0+26,z
	std	0+42,z
	ldx	42,z
	stx	4,z
	tzy	
	xgdy	
	addd	#4
	xgdy	
	ldx	44,z
	stx	2,y
	ldd	2+4,z
	addd	#-134217728       & $FFFF
	std	2+46,z
	ldd	0+4,z
	adcb	#-134217728 >> 16 & $FF
	adca	#-134217728 >> 24 & $FF
	std	0+46,z
	ldx	46,z
	stx	4,z
	ldx	48,z
	stx	2,y
	ldx	12,z
	stx	0,z
	clre	
	ldd	#2684
	jsr	_EMULx
	ste	30,z
	std	32,z
	ldd	2+30,z
	addd	#335544       & $FFFF
	std	2+34,z
	ldd	0+30,z
	adcb	#335544 >> 16 & $FF
	adca	#335544 >> 24 & $FF
	std	0+34,z
	lde	_celsius
	aie	#-25
	jsr	_abs
	std	0,z
	lde	34,z
	ldd	36,z
	jsr	_EMULx
	ste	8,z
	tzy	
	xgdy	
	addd	#8
	xgdy	
	std	2,y
	lde	_celsius
	cpe	#24
	bgt	L2
	
	tye	
	jsr	_lnegate

L2	ldd	2+4,z
	addd	2+8,z
	std	2+50,z
	ldd	0+4,z
	adcb	1+8,z
	adca	0+8,z
	std	0+50,z
	ldx	50,z
	stx	4,z
	ldx	52,z
	stx	6,z
	ldab	4,z
	lsrb	
	clra	
	std	_humidity

	ais	#+54
	pulm	z
	rts


	section	.data

LC0	dc.b	063h,072h,063h,020h,072h,065h,063h,065h
	dc.b	069h,076h,065h,064h,020h,030h,078h,000h

	align	1	; ASM_OUTPUT_ASCII

LC1	dc.b	02Ch,020h,063h,061h,06Ch,063h,075h,06Ch
	dc.b	061h,074h,065h,064h,020h,030h,078h,000h

	align	1	; ASM_OUTPUT_ASCII

	section	.text
	align	1
_unload
	pshm	z
	ais	#-8
	tsz

	ste	4,z
	jsr	_SHT1x_result
	tstd	
	beq	L9
	
	ldy	4,z
	lde	0,y
	ande	#-16384
	beq	L5
	

L9	clrd	
	bra	L8
	

L5	ldy	#140
	sty	0,z
	ldy	#2
	sty	2,z
	lde	4,z
	clrd	
	jsr	_crc_generic
	stab	6,z
	ldy	4,z
	ldab	2,y
	cmpb	6,z
	beq	L6
	
	lde	#LC0
	jsr	_print_string
	ldy	4,z
	ldab	2,y
	clra	
	tde	
	jsr	_print_word
	lde	#LC1
	jsr	_print_string
	ldab	6,z
	clra	
	tde	
	jsr	_print_word
	jsr	_eol

L6	clre	
	ldy	4,z
	ldab	2,y
	cmpb	6,z
	bne	L7
	
	lde	#1

L7	ted	

L8
	ais	#+8
	pulm	z
	rts


	section	.bss
Lsync.6
	ds.b	1
Ltoggle.7
	ds.b	1

	section	.text
	align	1

	global	_sht1x_round
_sht1x_round
	pshm	z
	tsz

	ldab	Lsync.6
	clra	
	tde	
	cpe	#1
	beq	L17
	
	cpe	#2
	beq	L14
	
	jsr	_SHT1x_sync
	lde	#30
	jsr	_SHT1x_command
	tstd	
	lbeq	L11
	
	clr	Ltoggle.7
	ldab	#3
	stab	_meas+3
	ldab	#5
	stab	_meas+7
	ldab	#1
	stab	Lsync.6
	jmp	L10
	

L14	ldab	Ltoggle.7
	clra	
	tde	
	asle	
	asle	
	aie	#_meas
	jsr	_unload
	tstb	
	beq	L11
	
	ldab	Ltoggle.7
	eorb	#1
	stab	Ltoggle.7
	bne	L17
	
	jsr	_update

L17	ldab	#2
	stab	Lsync.6
	ldab	Ltoggle.7
	clra	
	tde	
	asle	
	asle	
	tey	
	xgdy	
	addd	#_meas
	xgdy	
	ldab	3,y
	clra	
	tde	
	jsr	_SHT1x_command
	tde	
	tste	
	bne	L10
	

L11	clr	Lsync.6

L10	pulm	z
	rts


	section	.bss
_meas
	ds.b	8
_celsius
	ds.b	2
_fahrenheit
	ds.b	2
_humidity
	ds.b	2


	end
